`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/05/15 19:48:32
// Design Name: 
// Module Name: ASCII_decoder
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

`include "global.vh"

module ASCII_decoder(
    ASCII_code, 
    key_down,
    last_change,
    caps_lock,
    rst,
    key_release,
    clk
    );

    output reg [6:0] ASCII_code;
    input [511:0] key_down;
    input [8:0] last_change;
    input caps_lock;
    input rst, clk;
    input key_release;

    reg [6:0] next_ASCII_code;
    
    always @*
        if ((~caps_lock) && ~(key_down[`LEFT_SHIFT] || key_down[`RIGHT_SHIFT]) || (caps_lock) && (key_down[`LEFT_SHIFT] || key_down[`RIGHT_SHIFT]))
            case (last_change)
            `ASCII_KEY_A:
                next_ASCII_code = `ASCII_a;
            `ASCII_KEY_B:
                next_ASCII_code = `ASCII_b;
            `ASCII_KEY_C:
                next_ASCII_code = `ASCII_c;
            `ASCII_KEY_D:
                next_ASCII_code = `ASCII_d;
            `ASCII_KEY_E:
                next_ASCII_code = `ASCII_e;
            `ASCII_KEY_F:
                next_ASCII_code = `ASCII_f;
            `ASCII_KEY_G:
                next_ASCII_code = `ASCII_g;
            `ASCII_KEY_H:
                next_ASCII_code = `ASCII_h;
            `ASCII_KEY_I:
                next_ASCII_code = `ASCII_i;
            `ASCII_KEY_J:
                next_ASCII_code = `ASCII_j;
            `ASCII_KEY_K:
                next_ASCII_code = `ASCII_k;
            `ASCII_KEY_L:
                next_ASCII_code = `ASCII_l;
            `ASCII_KEY_M:
                next_ASCII_code = `ASCII_m;
            `ASCII_KEY_N:
                next_ASCII_code = `ASCII_n;
            `ASCII_KEY_O:
                next_ASCII_code = `ASCII_o;
            `ASCII_KEY_P:
                next_ASCII_code = `ASCII_p;
            `ASCII_KEY_Q:
                next_ASCII_code = `ASCII_q;
            `ASCII_KEY_R:
                next_ASCII_code = `ASCII_r;
            `ASCII_KEY_S:
                next_ASCII_code = `ASCII_s;
            `ASCII_KEY_T:
                next_ASCII_code = `ASCII_t;
            `ASCII_KEY_U:
                next_ASCII_code = `ASCII_u;
            `ASCII_KEY_V:
                next_ASCII_code = `ASCII_v;
            `ASCII_KEY_W:
                next_ASCII_code = `ASCII_w;
            `ASCII_KEY_X:
                next_ASCII_code = `ASCII_x;
            `ASCII_KEY_Y:
                next_ASCII_code = `ASCII_y;
            `ASCII_KEY_Z:
                next_ASCII_code = `ASCII_z;
            default:
                next_ASCII_code = 7'd0;
            endcase
        else
            case (last_change)
            `ASCII_KEY_A:
                next_ASCII_code = `ASCII_A;
            `ASCII_KEY_B:
                next_ASCII_code = `ASCII_B;
            `ASCII_KEY_C:
                next_ASCII_code = `ASCII_C;
            `ASCII_KEY_D:
                next_ASCII_code = `ASCII_D;
            `ASCII_KEY_E:
                next_ASCII_code = `ASCII_E;
            `ASCII_KEY_F:
                next_ASCII_code = `ASCII_F;
            `ASCII_KEY_G:
                next_ASCII_code = `ASCII_G;
            `ASCII_KEY_H:
                next_ASCII_code = `ASCII_H;
            `ASCII_KEY_I:
                next_ASCII_code = `ASCII_I;
            `ASCII_KEY_J:
                next_ASCII_code = `ASCII_J;
            `ASCII_KEY_K:
                next_ASCII_code = `ASCII_K;
            `ASCII_KEY_L:
                next_ASCII_code = `ASCII_L;
            `ASCII_KEY_M:
                next_ASCII_code = `ASCII_M;
            `ASCII_KEY_N:
                next_ASCII_code = `ASCII_N;
            `ASCII_KEY_O:
                next_ASCII_code = `ASCII_O;
            `ASCII_KEY_P:
                next_ASCII_code = `ASCII_P;
            `ASCII_KEY_Q:
                next_ASCII_code = `ASCII_Q;
            `ASCII_KEY_R:
                next_ASCII_code = `ASCII_R;
            `ASCII_KEY_S:
                next_ASCII_code = `ASCII_S;
            `ASCII_KEY_T:
                next_ASCII_code = `ASCII_T;
            `ASCII_KEY_U:
                next_ASCII_code = `ASCII_U;
            `ASCII_KEY_V:
                next_ASCII_code = `ASCII_V;
            `ASCII_KEY_W:
                next_ASCII_code = `ASCII_W;
            `ASCII_KEY_X:
                next_ASCII_code = `ASCII_X;
            `ASCII_KEY_Y:
                next_ASCII_code = `ASCII_Y;
            `ASCII_KEY_Z:
                next_ASCII_code = `ASCII_Z;
            default:
                next_ASCII_code = 7'd0;
            endcase

    always @(posedge clk or posedge rst)
        if (rst)
            ASCII_code <= 7'd0;
        else
            ASCII_code <= next_ASCII_code;
    
endmodule




