`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/05/11 19:48:32
// Design Name: 
// Module Name: key_decoder
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////
`include "global.vh"

module key_to_note_decoder(
    note_result_left,
    note_result_right, 
    select_in,
    clk,
    rst,
    display_in_1,
    display_in_0,
    DIP_double_tone
    );

    output reg [21:0] note_result_left, note_result_right;
    output reg [3:0] display_in_1, display_in_0;
    input clk, rst;
    input [6:0] select_in;
    input DIP_double_tone;

    reg [21:0] result_tmp_left, result_tmp_right;
    reg [3:0] display_in_1_tmp, display_in_0_tmp;
    
    always @*
    if (DIP_double_tone == 1'b0)
        case (select_in)
            `ASCII_c:
            begin
                result_tmp_left = `mid_do;
                result_tmp_right = `mid_do;
            end
            `ASCII_d:
            begin
                result_tmp_left = `mid_re;
                result_tmp_right = `mid_re;
            end
            `ASCII_e:
            begin
                result_tmp_left = `mid_mi;
                result_tmp_right = `mid_mi;
            end
            `ASCII_f:
            begin
                result_tmp_left = `mid_fa;
                result_tmp_right = `mid_fa;
            end
            `ASCII_g:
            begin
                result_tmp_left = `mid_so;
                result_tmp_right = `mid_so;
            end
            `ASCII_a:
            begin
                result_tmp_left = `mid_la;
                result_tmp_right = `mid_la;
            end
            `ASCII_b:
            begin
                result_tmp_left = `mid_si;
                result_tmp_right = `mid_si;
            end
            `ASCII_C:
            begin
                result_tmp_left = `high_do;
                result_tmp_right = `high_do;
            end
            `ASCII_D:
            begin
                result_tmp_left = `high_re;
                result_tmp_right = `high_re;
            end
            `ASCII_E:
            begin
                result_tmp_left = `high_mi;
                result_tmp_right = `high_mi;
            end
            `ASCII_F:
            begin
                result_tmp_left = `high_fa;
                result_tmp_right = `high_fa;
            end
            `ASCII_G:
            begin
                result_tmp_left = `high_so;
                result_tmp_right = `high_so;
            end
            `ASCII_A:
            begin
                result_tmp_left = `high_la;
                result_tmp_right = `high_la;
            end
            `ASCII_B:
            begin
                result_tmp_left = `high_si;
                result_tmp_right = `high_si;
            end
            default:
            begin
                result_tmp_left = 22'd0;
                result_tmp_right = 22'd0;
            end 
        endcase
    else
        case (select_in)
            `ASCII_c:
            begin
                result_tmp_left = `mid_do;
                result_tmp_right = `mid_mi;
            end
            `ASCII_d:
            begin
                result_tmp_left = `mid_re;
                result_tmp_right = `mid_fa;
            end
            `ASCII_e:
            begin
                result_tmp_left = `mid_mi;
                result_tmp_right = `mid_so;
            end
            `ASCII_f:
            begin
                result_tmp_left = `mid_fa;
                result_tmp_right = `mid_la;
            end
            `ASCII_g:
            begin
                result_tmp_left = `mid_so;
                result_tmp_right = `mid_si;
            end
            `ASCII_a:
            begin
                result_tmp_left = `mid_la;
                result_tmp_right = `mid_la; 
            end
            `ASCII_b:
            begin
                result_tmp_left = `mid_si;
                result_tmp_right = `mid_si;
            end
            `ASCII_C:
            begin
                result_tmp_left = `high_do;
                result_tmp_right = `high_mi;
            end
            `ASCII_D:
            begin
                result_tmp_left = `high_re;
                result_tmp_right = `high_fa;
            end
            `ASCII_E:
            begin
                result_tmp_left = `high_mi;
                result_tmp_right = `high_so;
            end
            `ASCII_F:
            begin
                result_tmp_left = `high_fa;
                result_tmp_right = `high_la;
            end
            `ASCII_G:
            begin
                result_tmp_left = `high_so;
                result_tmp_right = `high_si;
            end
            `ASCII_A:
            begin
                result_tmp_left = `high_la;
                result_tmp_right = `high_la;
            end
            `ASCII_B:
            begin
                result_tmp_left = `high_si;
                result_tmp_right = `high_si;
            end
            default:
            begin
                result_tmp_left = 22'd0;
                result_tmp_right = 22'd0;
            end 
        endcase

    always @*
        case (select_in)
            `ASCII_c:
            begin
                display_in_1_tmp = 4'd0;
                display_in_0_tmp = 4'd1;
            end
            `ASCII_d:
            begin
                display_in_1_tmp = 4'd2;
                display_in_0_tmp = 4'd3;
            end
            `ASCII_e:
            begin
                display_in_1_tmp = 4'd4;
                display_in_0_tmp = 4'd5;
            end
            `ASCII_f:
            begin
                display_in_1_tmp = 4'd6;
                display_in_0_tmp = 4'd7;
            end
            `ASCII_g:
            begin
                display_in_1_tmp = 4'd8;
                display_in_0_tmp = 4'd1;
            end
            `ASCII_a:
            begin
                display_in_1_tmp = 4'd9;
                display_in_0_tmp = 4'd7;
            end
            `ASCII_b:
            begin
                display_in_1_tmp = 4'd8;
                display_in_0_tmp = 4'd5;
            end
            `ASCII_C:
            begin
                display_in_1_tmp = 4'd0;
                display_in_0_tmp = 4'd1;
            end
            `ASCII_D:
            begin
                display_in_1_tmp = 4'd2;
                display_in_0_tmp = 4'd3;
            end
            `ASCII_E:
            begin
                display_in_1_tmp = 4'd4;
                display_in_0_tmp = 4'd5;
            end
            `ASCII_F:
            begin
                display_in_1_tmp = 4'd6;
                display_in_0_tmp = 4'd7;
            end
            `ASCII_G:
            begin
                display_in_1_tmp = 4'd8;
                display_in_0_tmp = 4'd1;
            end
            `ASCII_A:
            begin
                display_in_1_tmp = 4'd9;
                display_in_0_tmp = 4'd7;
            end
            `ASCII_B:
            begin
                display_in_1_tmp = 4'd8;
                display_in_0_tmp = 4'd5;
            end
            default:
            begin
                display_in_1_tmp = 4'd10;
                display_in_0_tmp = 4'd10;
            end 
        endcase

    always @(posedge clk or posedge rst)
        if (rst)
        begin
            note_result_left <= 22'd0;
            note_result_right <= 22'd0;
            display_in_1 <= 4'd10;
            display_in_0 <= 4'd10;
        end
        else
        begin
            note_result_left <= result_tmp_left;
            note_result_right <= result_tmp_right;
            display_in_1 <= display_in_1_tmp;
            display_in_0 <= display_in_0_tmp;
        end
    
endmodule




