`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/04/22 19:35:26
// Design Name: 
// Module Name: note_gen
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

module note_gen(
    clk,
    rst,
    note_div_left,
    note_div_right,
    audio_left,
    audio_right
    );

    output [15:0] audio_left;
    output [15:0] audio_right;
    input clk, rst;
    input [21:0] note_div_left, note_div_right;

    reg [21:0] left_clk_cnt_next, left_clk_cnt;
    reg left_clk, left_clk_next;

    reg [21:0] right_clk_cnt_next, right_clk_cnt;
    reg right_clk, right_clk_next;

    //note freq for left
    always @(posedge clk or posedge rst)
        if (rst)
            begin
            left_clk_cnt <= 22'd0;
            left_clk <= 1'b0;
            end
        else
            begin
            left_clk_cnt <= left_clk_cnt_next;
            left_clk <= left_clk_next;
            end

    always @*
        if (left_clk_cnt == note_div_left)
            begin
            left_clk_cnt_next = 22'd0;
            left_clk_next = ~left_clk;
            end
        else
            begin
            left_clk_cnt_next = left_clk_cnt + 1'b1;
            left_clk_next = left_clk;
            end
    
    always @(posedge clk or posedge rst)
        if (rst)
            begin
            right_clk_cnt <= 22'd0;
            right_clk <= 1'b0;
            end
        else
            begin
            right_clk_cnt <= right_clk_cnt_next;
            right_clk <= right_clk_next;
            end

    always @*
        if (right_clk_cnt == note_div_right)
            begin
            right_clk_cnt_next = 22'd0;
            right_clk_next = ~right_clk;
            end
        else
            begin
            right_clk_cnt_next = right_clk_cnt + 1'b1;
            right_clk_next = right_clk;
            end


    assign audio_left = (left_clk == 1'b0) ? 16'hB000 : 16'h5FFF;
    assign audio_right = (right_clk == 1'b0) ? 16'hB000 : 16'h5FFF;  

endmodule




